@mixin anim-filter($filter, $value) {
    -webkit-filter: #{$filter}unquote("(#{$value})");
    -moz-filter: #{$filter}unquote("(#{$value})");
    -ms-filter: #{$filter}unquote("(#{$value})");
    filter: #{$filter}unquote("(#{$value})"); 
}

@mixin filter-brightness($valeur) {
    filter: brightness($valeur);
    -webkit-filter: brightness($valeur);
    -moz-filter: brightness($valeur);
    -o-filter: brightness($valeur);
    -ms-filter: brightness($valeur);
}

@mixin border-radius($radius) {
    -webkit-border-radius: $radius;
    -moz-border-radius: $radius;
    -ms-border-radius: $radius;
    border-radius: $radius;
}

@mixin transition($type,$duree) {
    -webkit-transition:$type $duree;
    -moz-transition:$type $duree;
    -o-transition:$type $duree;
    transition:$type $duree;
    //transition-timing-function: ease-in-out;
}

@mixin backface-visibility() {
    -webkit-column-break-inside:avoid;
    -moz-column-break-inside:avoid;
    -o-column-break-inside:avoid;
    -ms-column-break-inside:avoid;
    column-break-inside:avoid;
    -webkit-backface-visibility:hidden;
}

@mixin scale($largeur,$hauteur) {
    -ms-transform: scale($largeur, $hauteur); /* IE 9 */
    -webkit-transform: scale($largeur, $hauteur); /* Safari */
    transform: scale($largeur, $hauteur);
}

@mixin rotate($deg) {
    -ms-transform: rotate($deg); /* IE 9 */
    -webkit-transform: rotate($deg); /* Chrome, Safari, Opera */
    transform: rotate($deg);
}

@mixin column($nb) {
    columns : $nb;
    -webkit-columns: $nb;
    -moz-columns: $nb;
}

@mixin flex {
    display: -webkit-box;
    display: -webkit-flex;
    display: -moz-flex;
    display: -ms-flexbox;
    display: flex;
}

@mixin flex-flow($values: (row nowrap)) {
    // No Webkit Box fallback.
    -webkit-flex-flow: $values;
    -moz-flex-flow: $values;
    -ms-flex-flow: $values;
    flex-flow: $values;
}

@mixin flex-direction($value: row) {
    @if $value == row-reverse {
        -webkit-box-direction: reverse;
        -webkit-box-orient: horizontal;
    } @else if $value == column {
        -webkit-box-direction: normal;
        -webkit-box-orient: vertical;
    } @else if $value == column-reverse {
        -webkit-box-direction: reverse;
        -webkit-box-orient: vertical;
    } @else {
        -webkit-box-direction: normal;
        -webkit-box-orient: horizontal;
    }
    -webkit-flex-direction: $value;
    -moz-flex-direction: $value;
    -ms-flex-direction: $value;
    flex-direction: $value;
}

@mixin flex-grow($int: 0) {
    -webkit-box-flex: $int;
    -webkit-flex-grow: $int;
    -moz-flex-grow: $int;
    -ms-flex-positive: $int;
    flex-grow: $int;
}

@mixin justify-content($value: flex-start) {
    @if $value == flex-start {
        -webkit-box-pack: start;
        -ms-flex-pack: start;
    } @else if $value == flex-end {
        -webkit-box-pack: end;
        -ms-flex-pack: end;
    } @else if $value == space-between {
        -webkit-box-pack: justify;
        -ms-flex-pack: justify;
    } @else if $value == space-around {
        -ms-flex-pack: distribute;
    } @else {
        -webkit-box-pack: $value;
        -ms-flex-pack: $value;
    }
    -webkit-justify-content: $value;
    -moz-justify-content: $value;
    justify-content: $value;
}

@mixin align-items($value: stretch) {
    @if $value == flex-start {
        -webkit-box-align: start;
        -ms-flex-align: start;
    } @else if $value == flex-end {
        -webkit-box-align: end;
        -ms-flex-align: end;
    } @else {
        -webkit-box-align: $value;
        -ms-flex-align: $value;
    }
    -webkit-align-items: $value;
    -moz-align-items: $value;
    align-items: $value;
}

@mixin align-self($value: auto) {
    // No Webkit Box Fallback.
    -webkit-align-self: $value;
    -moz-align-self: $value;
    @if $value == flex-start {
        -ms-flex-item-align: start;
    } @else if $value == flex-end {
        -ms-flex-item-align: end;
    } @else {
        -ms-flex-item-align: $value;
    }
    align-self: $value;
}

@mixin align-content($value: stretch) {
    // No Webkit Box Fallback.
    -webkit-align-content: $value;
    -moz-align-content: $value;
    @if $value == flex-start {
        -ms-flex-line-pack: start;
    } @else if $value == flex-end {
        -ms-flex-line-pack: end;
    } @else {
        -ms-flex-line-pack: $value;
    }
    align-content: $value;
}

@mixin flex-wrap($value: nowrap) {
    // No Webkit Box fallback.
    -webkit-flex-wrap: $value;
    -moz-flex-wrap: $value;
    @if $value == nowrap {
        -ms-flex-wrap: none;
    } @else {
        -ms-flex-wrap: $value;
    }
    flex-wrap: $value;
}

@mixin animated-borders($border-width,$border-color,$border-animation-duration,$border-animation-timing)
{
    // Define duration of each border's animation
    $solo-animation: $border-animation-duration/4;

    .border-top,
    .border-bottom,
    .border-right,
    .border-left {
        position: absolute;
        overflow: hidden;
        &:after {
            content: "";
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background: $border-color;
            transition: transform $solo-animation $border-animation-timing;
            will-change: transform;
        }
    }

  .border-top,.border-bottom { width:  100%;height: $border-width; left: 0; }
  .border-right, .border-left { width: $border-width;height: 100%;top: 0; }
  .border-top { top: 0; }
  .border-bottom { bottom: 0; }
  .border-right { right: 0; }
  .border-left { left: 0; }

  //
  // States
  ///////////////////////////////////////////
  .plus {
    .border-top:after {
      transition-delay: $solo-animation*3;
      transform: translate3d(-100%,0,0);
    }
    .border-bottom:after {
      transition-delay: $solo-animation;
      transform: translate3d(100%,0,0);
    }
    .border-right:after {
      transition-delay: $solo-animation*2;
      transform: translate3d(0,-100%,0);
    }
    .border-left:after {
      transform: translate3d(0,100%,0);
    }
    
    &:hover {
      .border-top:after,
      .border-bottom:after,
      .border-right:after,
      .border-left:after {
        transform: translate3d(0,0,0);
      }
      .border-top:after {
        transition-delay: 0s;
      }
      .border-bottom:after {
        transition-delay: $solo-animation*2;
      }
      .border-right:after {
        transition-delay: $solo-animation;
      }
      .border-left:after {
        transition-delay: $solo-animation*3;
      }
    }
  }
}